@echo off
set curdir=%cd%
set icon=iconc.png
set name=template
set opname=DEMO
set desc=C_SDK_Test
set compprgm=NO
set openprgm=NO
set graphx=NO
set /p curdir="Output Directory (Default=Current Script Directory): "
if "%curdir%"=="%cd%" (
echo Using Default...
)
set /p name="Project Name: "
if "%name%"=="template" (
echo Using Default...
)
set /p icon="Icon (Default=iconc.png): "
if "%icon%"=="iconc.png" (
echo Using Default...
)
:toolong
set /p opname="Output Program Name: "
call :strlen opnamelen opname
if %opnamelen% gtr 8 (
echo Program name exceeds 8 character limit!
goto :toolong
)
if "%opname%"=="DEMO" (
echo Using Default...
)
set /p desc="Description: "
if "%desc%"=="C_SDK_Test" (
echo Using Default...
)
set /p compprgm="Compress Output? (YES or NO, Default=NO): "
if "%compprgm%"=="NO" (
echo Using Default...
)
set /p graphx="Will this Project contain sprites? (Y or N, Default=N): "
if "%graphx%"=="NO" (
echo Using Default...
)
mkdir "%curdir%\%name%"
xcopy "%CEDEV%\examples\template" "%curdir%\%name%" /E
@echo @echo off> "%curdir%\%name%\openfiles.cmd"
@echo start "" "%curdir%\%name%\src\main.c">> "%curdir%\%name%\openfiles.cmd"
@echo start notepad "%curdir%\%name%\makefile">> "%curdir%\%name%\openfiles.cmd"
if %graphx%==Y (
mkdir "%curdir%\%name%\src\gfx"
xcopy "%CEDEV%\examples\gfx_sprite\src\gfx" "%curdir%\%name%\src\gfx" /E
@echo @echo on> "%curdir%\%name%\makegfx.cmd"
@echo make gfx>> "%curdir%\%name%\makegfx.cmd"
@echo start "" "%curdir%\%name%\src\gfx">> "%curdir%\%name%\openfiles.cmd"
@echo start "" "%curdir%\%name%\src\gfx\convpng.ini">> "%curdir%\%name%\openfiles.cmd"
)
if %graphx%==y (
mkdir "%curdir%\%name%\src\gfx"
xcopy "%CEDEV%\examples\gfx_sprite\src\gfx" "%curdir%\%name%\src\gfx" /E
@echo @echo on> "%curdir%\%name%\makegfx.cmd"
@echo make gfx>> "%curdir%\%name%\makegfx.cmd"
@echo start "" "%curdir%\%name%\src\gfx">> "%curdir%\%name%\openfiles.cmd"
@echo start "" "%curdir%\%name%\src\gfx\convpng.ini">> "%curdir%\%name%\openfiles.cmd"
)
@echo NAME        ?= %opname%> "%curdir%\%name%\makefile"
@echo COMPRESSED  ?= %compprgm%>> "%curdir%\%name%\makefile"
@echo ICON        ?= %icon%>> "%curdir%\%name%\makefile"
@echo DESCRIPTION ?= "%desc%">> "%curdir%\%name%\makefile"
@echo include $(CEDEV)/include/.makefile>> "%curdir%\%name%\makefile"
@echo @echo on> "%curdir%\%name%\makedir.cmd"
@echo make>> "%curdir%\%name%\makedir.cmd"
set /p openprgm="Open Project for editing? (Y or N, Default=N): "
if "%openprgm%"=="NO" (
echo Using Default...
)
if %openprgm%==Y (
start "" "%curdir%\%name%\src\main.c"
start notepad "%curdir%\%name%\makefile"
if %graphx%==y (
start "" "%curdir%\%name%\src\gfx"
start "" "%curdir%\%name%\src\gfx\convpng.ini"
)
if %graphx%==Y (
start "" "%curdir%\%name%\src\gfx"
start "" "%curdir%\%name%\src\gfx\convpng.ini"
)
)
if %openprgm%==y (
start "" "%curdir%\%name%\src\main.c"
start notepad "%curdir%\%name%\makefile"
if %graphx%==y (
start "" "%curdir%\%name%\src\gfx"
start "" "%curdir%\%name%\src\gfx\convpng.ini"
)
if %graphx%==Y (
start "" "%curdir%\%name%\src\gfx"
start "" "%curdir%\%name%\src\gfx\convpng.ini"
)
)
echo Exiting . . .
timeout 1 > nul
goto :eof

:strlen <resultVar> <stringVar>
(   
    setlocal EnableDelayedExpansion
    set "s=!%~2!#"
    set "len=0"
    for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
        if "!s:~%%P,1!" NEQ "" ( 
            set /a "len+=%%P"
            set "s=!s:~%%P!"
        )
    )
)
( 
    endlocal
    set "%~1=%len%"
    exit /b
)